Sorry for the issues with a couple of problems
Problem A of tc/div2 (Finding Sasuke)
Problem B of tc/div2 (A New Technique)
Problem C of tc/C div2/A div1 (Perform Easily)
Problem D of tc/D div2/B div1 (Shurikens)
Problem E of tc/E div2/C div1 (Solo mid Oracle)
Problem F of tc/D div1 (Roads and Ramen)
Problem E of div1 (A Convex Game)
almost got the idea of DIV2 C :(
It's really interesting who was the author. I will say that it's really interesting to know which problem was made by whom. Golovanov399, could you please show us!
YES! Please Golovanov399! please!
The author of Div1A and Div1C is Golovanov399, I am the author of all other problems.
Thank you!
div2 D was way easier than div2 C !! anyways great contest indeed !!
Can't agree with this. I solved Div2 C in less than 15 minutes, and couldn't solve Div2 D at all. IMHO, the second part of solution in editorial is more difficult than it could be, because after sorting the pair array, we can simply use two pointer method
I think proof of Div1 D looks incomplete. You should also consider a case when diameter and optimal path intersect, I think they are a bit different.
Please mark your comment with spoilers. Some participants might want to upsolve without spoilers.
Well, reading comments under editorial is a bit reckless if you want to solve problems without spoilers
Yeah, little bit.
Correct me if I'm wrong, but I think it still holds when $$$C = D$$$ (optimal path intersects diameter) and when $$$D = F$$$ (optimal path begins somewhere on diameter), so that should cover all the cases. The proof does not make assumptions on edges existing between nodes in the diagram, so setting paths have zero length should be fine.
If C=D then everything is fine, but if diameter and considered path have some edges in common then it is a bit different
ah, i see. i agree that it's incomplete then, there's no way to cover that without another case.
I'm guessing most people figured out the proof for that case by themselves, but I'll share mine for the sake of completeness (sorry for necroposting lol)
Firstly, define $$$p(U, V)$$$ to be $$$1$$$ if the parity of the number of stone roads on the path from $$$U$$$ to $$$V$$$ is odd, and $$$0$$$ otherwise. Also, define $$$|UV|$$$ as the length of the path from $$$U$$$ to $$$V$$$.
Once again, suppose that $$$AB$$$ is a diameter of the tree, and $$$EF$$$ is a maximum-length path with an even number of stone roads.
Let's first show that $$$p(A, F) \neq p(E, B)$$$. There's two cases, depending on $$$p(C, D)$$$.
Case 1: $$$p(C, D) = 0$$$
Since $$$p(A, B) = 1$$$, it must be true that $$$p(A, C) \neq p(D, B)$$$. Since $$$p(E, F) = 0$$$, it must be true that $$$p(E, C) = p(D, F)$$$. The condition holds.
Case 2: $$$p(C, D) = 1$$$
The same thing happens, but the equality and inequality flip places. $$$p(A, C) = p(D, B)$$$ and $$$p(E, C) \neq p(D, F)$$$. In this case, the condition holds as well.
Without loss of generality, suppose that $$$p(A, F) = 0$$$. It must be true that $$$|EB| \leq |AB|$$$, since the latter is a diameter. Hence $$$|EC| \leq |AC|$$$ and thus $$$|EF| \leq |AF|$$$. Once again, we've constructed a valid path which is at least as good, and has an endpoint at either $$$A$$$ or $$$B$$$. This is a contradiction.
Golovanov399 why my sol for div2 D getting tle https://codeforces.me/contest/1435/submission/96683823 please help...
Try
taken.lower_bound()
instead oflower_bound(all(taken))
Why does this work?
In simple words lower_bound(all(v)) uses random access iterators and works well only for vectors, arrays etc. whereas s.lower_bound is a function built to handle binary search for sets, multiset etc where elements cannot be randomly accessed. there is a blog about this, try searching if interested further.
Do you have that link?
Check the comments
In c++ set or multiset, it is better to use the in-built lower bound function as in the worst case, it has logarithmic complexity. The other one has a quadratic worst case time complexity.
Is tourist's submission for problem E somehow rejudged?
Yeah, it was stated that $$$v_i > 0$$$, while in fact it was generated (and then validated) that they can be zeroes. It turned out that the second Gennady's submission failed just because of that (and then he wasted the last hour finding out what was wrong).
He came first without having to solve D, so it is all good. Otherwise, the round would have been unrated for him right?
I guess yes.
He doesn’t need D and he can be the first.
If someone had solved all problems, I'm pretty sure tourist wouldn't have come 1st. If the statement was correct initially, he would have probably spent the last hour on solving D maybe.
What a good way of preventing someone from AKing your contest.
(Just kidding. )
There's O(n) solution for div2 D using stack. See my code.
But it's hard to explain for me..
Wow! That's an amazing solution! Thanks!
Great! Thanks for the code
Did anyone solve D2C with DP? Is it even possible?
I did and got FST :(
Yes I tried Div2 C with DP, but it failed on test-case 25. But I realise now that it is not possible to solve it using DP. Here is my submission 96694460
Atleast in the way I have defined my DP states.
Same pretest got us :(
I believe my solution has the same idea 96688698, but why do you think it's not possible?
Because in DP solution answer of current state is dependent on previous state and we minimise the difference between minimal and maximal fret. But consider the 25th Test case.
101 146 175
if we subtract1 96 100
respectively from it we obtain our answer.But DP solution will choose :-
96 96 100
for subtraction, because difference between 5 and 50 is smaller as compared to 100 and 50.Lol, I combined our solutions and it got AC. That's weird. I also added sorts to my solution as you did 96712200
I have a DP + Greedy solution. Here's my submission.
Explanation — First comes the greedy part. By observation, it can be seen that after sorting both the notes and $$$a_{i}$$$, it will always be optimal to first choose some elements from the first string, then some from the second, and so on. So, after choosing a particular string $$$k$$$ for some $$$i-th$$$ note, the $$$(i+1)-th$$$ note will be always from a string $$$j\ge k$$$. This can be implemented using DP.
In my solution, $$$dp_{i,k,j}$$$ is the state where the $$$i-th$$$ note is being considered to be assigned string $$$j$$$ and the $$$(i-1)-th$$$ note has been assigned the string $$$k$$$. The
second.first
,second.second
andfirst
fields of the states represent the minimum value chosen till now, maximum value chosen till now and their difference respectively.Thanks very much for the code. Codes speak for themselves
Was able to solve B today but not A :|
Me too, feels really bad. Another bad thing is stuck on C but then find D so easy after contest
Div2C : Each note can be played on a specific range of frets. So out of all such ranges, find the minimum end point (at least one note cannot be played using a higher numbered fret) and the maximum start point (at least one note cannot be played using a lower numbered fret) and output max(0, max_start — min_end). Can anyone point what is wrong with this approach and provide a simple counter test?
Firstly, it would not work on test:
1 1 1 1 1 5
2
10 13
The best solution is to choose 1 note for 10 and 5 for 13. So, the answer will be 1, but your code gives 0.
And also consider this testcase
1 1 1 1 1 5
3
6 8 10
max_start = 5 (10 — 5), min_end = 5 (6 — 1). Your code will give 0, but you cant get 5 from 8 (only 3 and 7).
I hope I understand you correctly.
Thanks! Got it.
k1ps thanks a lot for these test cases : )
can someone tell my why I am getting tle https://codeforces.me/contest/1435/submission/96685352 in problem D.
Your solution is O(N^2).
final.size()
will become N gradually. Since the outer loop is running 2*N times, complexity is O(N^2).Note: 1+2+3+...N = N(N+1)/2 = O(N^2)
Problem D2C/D1A has a DP tag in it. I would really like someone to help me with the DP solution for D2C/D1A if it is possible. Thanks in advance !
I have shared my DP + Greedy approach here.
i got TLE with N*M complexity on B, helllooo? what's wrong with this " https://codeforces.me/contest/1435/submission/96705114 " ??? i got accepted with " https://codeforces.me/contest/1435/submission/96705022 "
Super easy solutions and implementation for problems Div2 D and Div2 E: Div2 D: 96705496 Div2 E: 96705529
D is much easier that the one u linked, just one stack and O(n).
Yes, I see. Complexity can be further reduced to O(N).
Thanks for the solution, mate! Very nice observations
In problem Div2D, if we are getting queries of form "— num", we are updating the lower bound , what we need to do when we get query of type "+" ? I didn't understand this line from editorial "and remove any one of them, because we cannot remove any other shuriken"
Question D div2 can be solved in O (n) rather than O(n*log(n))with simple stack and easier implementation, here is an ac solution. https://codeforces.me/contest/1435/submission/96693538
(Only the solve1() function is the code for this qn)
4 + - 1 + + - 4 + - 2 - 3
I have hacked my own solution for Div 1 B/Div 2 D with the above test case. My submission:- 96706130 Systems tests are so weak Golovanov399 amethyst0 Endagorion AndreySergunin
Wow, I'm really surprised by that considering how easy it is to make good YES tests: just make a bunch of small random YES tests and it's really easy to combine them into 1 big test(just increase the numbers in each small test by the sum of $$$n$$$ of the small tests before it)
each price from 1 to n occurs exactly once
Div2 D O(n) solution explanation: note that
Bingo! We've just solved this problem in O(n) using stack (going in the reversed order, putting goods on a stack and then taking them from the top of the stack and putting on the showcase). The only tricky moment left: you must pay attention to the amount of shurikens to avoid the lack of them (e.g. example 2 from the problem).
Someone please tell where I went wrong 96696335
fixed
Can anyone tell me why my submission for Perform Easily failed pretest 9 : 96698325 ?
My logic :
The maximal and minimal frets are obviously useful frets i.e. they are used by some fret. So I first sorted the notes and then fixed the "minimal used fret" by using the frets required by the first note by the various strings (the logic being that the smallest note will use the smallest fret from all possible combinations). So out of the 6 frets usable by the first note, one of them should be the "minimal" fret of the optimum set. Then I just binary search for the right hand side by checking if all notes can be played for the specified minimal fret.
Div1 D can be solved via top trees without analyzing the problem.
It seems to be difficult to find any information regarding top trees. Do you have any article regarding this?
At a high level, top trees are just link-cut trees but with a BBST of light-children at each vertex, which allows you to do subtree queries. If you don't understand link-cut trees, learn those first.
The main paper for the popular splay-tree-based top trees is "Self-Adjusting Top Trees" by Tarjan and Werneck. This also contains references to alternate works by Frederickson and others which have alternative (but more complex) constructions, so you can read those for more background/theory.
I submitted a top-tree solution to this problem 96759325, but it's rather complex and not a great way to learn. The quintessential top-tree problem is SONE1 at http://www.lydsy.com/JudgeOnline/problem.php?id=3153, but the site seems to be down right now.
https://negiizhao.blog.uoj.ac/blog/4912
Here is a brief introduction of top trees (with some applications I could come up with), but it is in Chinese. I may supply an English version later.
How to solve Div 2D using priority queue ?? I don't understand this line from editorial. Otherwise, for all shurikens that had a lower bound of something less than x we increase it to x, and remove any one of them, why do we have to remove any one of them when we exactly know which one to remove , how to handle the other type of operation "+" type .
You can check this solution 96682108
can you please explain the idea behind your solution .
We can iterate an array in a reverse order. (Example 1)
we can create an array like this [-1,-1,2,-1,3,-1,1,4] where -1 indicates that the element was inserted(+ sign). Now maintain a min-heap. Iterate backward on this array, we will keep on inserting the elements. We will first insert 4 and 1. Now whenever we land on -1, it means at this point, some shuriken must have been added on the showcase) which can only be either 4 or 1(Since they are sold at the last). So, we can safely remove the minimum element from the heap and add it to the answer. If the heap is found empty at -1 or if we find one of the element in the heap is less than the element to be insert then the array is inconsistent. Also, we can check if number of +'s is equal to n. If it is not equal then the answer is "NO". 96748102
Hey, can you elaborate this part
we find one of the element in the heap is less than the element to be insert then the array is inconsistent.
?The element x which is currently being added indicates the element was sold at this moment and the elements in the heap stores the element already sold out. It also means that at this point, the elements which we have on the showcase are x and all the elements in the heap. By what question says, x has to be the minimum as the customers purchases the minimum element on showcase, but in this case, there is some element in our heap which is less than x and the customer have purchased x instead of that minimum element in the heap. So, it is inconsistent.
Thanks for the explanation. Can you please explain how is this safe? we can safely remove the minimum element from the heap and add it to the answer
Why my submission link1 getting TLE but when i changed vector size to (n*m + 5) it get accepted link2 ?
This is a common mistake when there are multiple testcases. It may take 500*500*t if you create/initialize 500*500 arrays every time, and that's about $$$2.5 \times 10^{10}$$$. The statements said that "Sum of $$$nm$$$ over all test cases does not exceed $$$250000$$$" so the second submission could pass.
About Problem 2E/1C: I didn't like this problem at all. It was boring and a detail-finding kind of problem where you know right after reading the problem that you can get to the solution if you are not lazy enough.
about the $$$-1$$$ part, we can just see that since $$$a>bc$$$, for each spell, whether complete or not, contributes positively to the damage. Hence the damage can be arbitrarily large. No need to think about overlapping parts, as is done in the editorial.
Linear time solution of div1B:
Consider the queries backwards. Then — x actually means adding shuriken with value x to the showcase, and + means deleting some shuriken. So we can maintain the sorted stack of all shurikens at the moment. On + we will delete the minimum from the stack (it's easy to see that it's always the best option), i.e. top element, and add it to the answer array. On — x we will check that x is less then the value on top of the stack and add it. If we successfully looked through all the queries we will just print the reversed answer array, and otherwise there's no answer. My code 96667703
I had a similar idea , which unfortunately didn't work. can you please explain what's the flaw with with the following logic.
Initialise cnt to zero . While processing the queries backwards , if we see + we increment the cnt variable by 1. When we see — x , we push x in the stack if x is less than top element otherwise we can pop atmost cnt number of elements from top of the stack such that now either the stack is empty or top of stack is greater than x.while popping from the stack we decrease the cnt by 1.
There is something I can not understand in the proof of 1D.
Tutorial says "Let AB be a diameter of the tree, and the optimal answer be EF." But it seems that in the given tree, AB is not a diameter.
Did I understand what the tutorial wanted to express wrongly? Could anyone explain it for me? Thank you in advance!
This is for the sake of brevity. You can see that the edge CB is a little bit longer than AC. Apparently that means that there are some nodes on a path between B and C
Ha, got it! Thank you sir!
can someone explain to me whats wrong with my algorithm 96738918 in D2C? i know my idea is wrong,but im confused whats wrong with it
The answer may not always be
abs(b[n]-a[6]-b[1]+a[1])
. An example:1 3 6 8 100 1000
3
1003 1250 1500
According to your code, the answer must be 502, but the correct one is 398.
Can someone explain A?
N is even .. So try to make every two element operation sum = 0
Suppose think there have two number a and b.
1. a=2 & b=3 both positive
Then answer is b=3 & -a=-2
2. a=2 & b=-3 neg
Then answer is -b=3 & a=2.
3. a=-2 & b=-3
then answer is b=-3 & -a=2
4. a=-2 & b=3
then answer is -b=-3 & a=-2
If have any query..please ask.
Can someone please tell me why my solution is wrong for Div2. A... 96650687
I printed all 1's if the sum of all elements of original array is 0 and I got wrong answer on 10th Test.
if the sum ever does happen to be 0, then you're printing 2 valid answers which is why you're getting WA. Just add a return statement.
Got it! Thanks
Could anyone recommend similar problems to div2C&|D?
Just search the tags
How to approach the problem E with ternary search( Proof of maximal value being a convex function) ??
Was div.2-D a standard problem? Everybody is saying that the problem is very easy but I could not come up with a simple idea for the problem. I was thinking of a heavy implementation solution.
The idea of problem D:- 1) pair every "+" with below "-" using upper bound. 2) check the order of elements with given order using stack
for better understanding, check out my code
I think there's also a O(n) solution for Div2 D using list and it's easier to explain.
We consider matching the '-' operations with '+' operations from "- 1" to "- n".
After we matched a '+' operation and a '-' operation, we remove them from the operation sequence.
So, when considering the operation "- x":
If the previous operation is "-", it's impossible to meet the requirements because we have already removed all the numerically smaller "-" operations.
Otherwise the previous operation is "+" and we can easily match this "-" operation with it.
This can be maintained with a list by recording the position of each "-" operation in the operation sequence.
My code
All problems(DIV2) are good and do not need a hard data structure. some observation and you can solve.
Except the one about ramen
I was talking about DIV2
Oh i was doing the original Technocup and there we had that problem about ramen, so i thought it was in div2 too
Div2 D can be solved going through the reversed query with a set. Every time we meet a "+" we can just say that the woman takes the one with the least price back. So if set's size is 0 the answer is NO. Else erase that element and add to the answer. Else if we meet a "- x" then x must be the less then the least element in the set now. If not, the answer is NO. If yes, insert x. 40 lines of code.
p.s. reverse the answer in the end
96676641
Can anyone tell me why am i getting TLE in div2B? An n^2 solution should have been fine ,right? 96669009
I think n^2 should be too slow (2,5e5)^2 is a lot
Oh. Can you kindly explain your approach for B then?
Oh i see the problem. Im sorry thought it was (nm)^2, but after seeing ur code i saw it's nm, which is ok. The problem must be creating a huge array vis, since all other things have a good time complexity.
p.s. I got ur sol accepted with changing vis size to n * m + 1
I don't know why I TLE in B :(( somebody help me, please!!!!!!! MY SUBMISSION
You used memset for 1000000 bytes in while loop for 100000.
https://codeforces.me/contest/1435/submission/96662042 can someone tell me what I am wrong?? I can't find anything wrong with my code. please...
the first matrix given gives you the column of the number and the second matrix gives you the row of that number
How to solve div2E with binary search?
How could anyone in A saw the row of array like: -a2, a1, -a4, a3, ..., -an, an-1. I mean, no advices on that path weren't given, is anyone sorted out how this works?
n is even, and you want to make two adjacent elements make a sum of 0.
if you have the array a1, a2 — make the sum a1*(-a2) + a2*(a1) = 0.
If you do it to every adjacent pair, the total sum will be 0.
Yeah, I understand that I need sum = 0, but I hadn't sorted out how to achieve this at the competition, so that's quite bad. That's pretty hard for me to find easiest ways to solve a problem.
Emmm. What you need to do is just practicing more and thinking more. I believe you can solve such problem quickly in a nearly future.
You can solve KOIREP from SPOJ if you have solved Div 2C/1A
Could someone please explain the solution of the div1E?I'm totally confused with the conclusion “the outcome of the game is defined by the index of the last move and the last difference between the elements”and“ if we fix the last index and gradually decrease the last difference, the grundy value will not decrease. ”
Why we used set<pair<int,pair<int,int>>> in div2C why can't we just keep track of the value(0-5) in an array of n
Could anyone please tell me some other solutions (except two pointers) of the problem Perform Easily? There are so many problem tags for this problem, so I guess there will be some interesting solutions (such as binary search).
I thought of a different approach and used lower bounds and upper bounds but it is failing at test case 9 can you tell me whats wrong with my code? you can go through this I posted this earlier Can Someone tell me why I my code fails at test case 9 96809688 I have used the approach that after sorting the notes the there cannot be a fret smaller than difference between first note and first string then I took two case 1. I found all the frets for every note which is just smaller or equal to the smallest fret. 2. I found all the frets for every note which is just larger or equal to the smallest fret. then I found the Min of differences obtained from these two.
Sorry, I don't understand your approach. However, there is a set of small data that your code can't get the right answer, maybe you can try to discover your mistakes through it.
Input
1 1 1 96 99 100
3
101 146 175
Output
50
Your answer
74
Good luck!
5 minutes left time to be ready : )
Thx for this round!